program lsusb;

{$mode objfpc}{$H+}

uses
 {$IFDEF UNIX}{$IFDEF UseCThreads}
 cthreads,
 {$ENDIF}{$ENDIF}
 Classes, SysUtils, LibUSB, CustApp
 { you can add units after this };

type

 { TLSUSB }

 TLSUSB = class(TCustomApplication)
 protected
  procedure DoRun; override;
 public
  constructor Create(TheOwner: TComponent); override;
  destructor Destroy; override;
  procedure WriteHelp; virtual;
 //List busses
 private
   procedure List_busses;
 end;

Function susb_get_string_simple( _dev_handle: PUSBDevHandle; _index:Longint): String;
const STRING_MAX_SIZE = 256;
var
   Buffer: array[0..STRING_MAX_SIZE] of Char;
begin
     Result:= '';
     if 0 = _index then exit;

     if 0 = usb_get_string_simple( _dev_handle, _index, Buffer, STRING_MAX_SIZE-1)
     then
         exit;
     Result:= StrPas( Buffer);
end;

{ TLSUSB }

procedure TLSUSB.List_busses;
var
   bus: PUSBBus;
   bus_index: Integer;
   dev: PUSBDevice;
   dev_index: Integer;
   procedure Handle_Device;
   var
      dev_handle: PUSBDevHandle;
      descriptor: PUSBDeviceDescriptor;
      Line: String;
      function sgss( _index:Longint): String;
      begin
           Result:= susb_get_string_simple( dev_handle, _index);
      end;
   begin
        dev_handle:= usb_open( dev);
        if nil = dev_handle then exit;

        try
           descriptor:= @(dev^.descriptor);
           Line
           :=
              Format( '     %.3d %.3d %04X:%04X', [bus_index, dev_index, descriptor^.idVendor, descriptor^.idProduct])
             +'('+sgss( descriptor^.iManufacturer)+')'
             +' '+sgss( descriptor^.iProduct     )+' '
             +'['+sgss( descriptor^.iSerialNumber)+']';
           WriteLn( Line);
        finally
               usb_close(dev_handle);
               end;
   end;
begin
     bus:= usb_get_busses;
     bus_index:= 0;
     while Assigned(bus)
     do
       begin
       WriteLn( 'Bus: ',bus^.dirname);
       dev:= bus^.devices;
       dev_index:= 0;
       while Assigned( dev)
       do
         begin
         WriteLn( '  Device: ',dev^.filename);
         Handle_Device;
         dev:= dev^.next;
         Inc( dev_index);
         end;
       bus:= bus^.next;
       Inc( bus_index);
       end;
end;

procedure TLSUSB.DoRun;
var
   ErrorMsg: String;
begin
     // quick check parameters
     ErrorMsg:=CheckOptions('h', 'help');
     if ErrorMsg<>''
     then
         begin
         ShowException(Exception.Create(ErrorMsg));
         Terminate;
         Exit;
     end ;

     // parse parameters
     if HasOption('h', 'help')
     then
         begin
         WriteHelp;
         Terminate;
         Exit;
         end;

     { add your program here }
     usb_init();
     usb_find_busses();
     usb_find_devices();
     List_busses;

     // stop program loop
     Terminate;
end;

constructor TLSUSB.Create(TheOwner: TComponent);
begin
     inherited Create(TheOwner);
     StopOnException:=True;
end;

destructor TLSUSB.Destroy;
begin
     inherited Destroy;
end;

procedure TLSUSB.WriteHelp;
begin
     { add your help code here }
     writeln('Usage: ', ExeName, ' -h');
end;

var
   Application: TLSUSB;
begin
     Application:=TLSUSB.Create(nil);
     Application.Title:='LSUSB';
     Application.Run;
     Application.Free;
end.

